      subroutine ResetAlready()      


      use Agrif_Util
#include "Param_BeforeCall_ResetAlready.h"
      

        call Sub_Loop_ResetAlready( Agrif_tabvars_i(14)%iarray0, Agrif_t
     &abvars_i(4)%iarray0, Agrif_tabvars_i(13)%iarray0, Agrif_tabvars_i(
     &2)%iarray0, Agrif_tabvars_l(23)%larray3)

      end


#include "Sub_Loop_ResetAlready.h"

      subroutine Agrif_update_np1
      

      use Agrif_Util
#include "Param_BeforeCall_Agrif_update_np1.h"
      

        call Sub_Loop_Agrif_update_np1( Agrif_tabvars_i(198)%iarray0, Ag
     &rif_tabvars_i(8)%iarray0, Agrif_tabvars_i(7)%iarray0, Agrif_tabvar
     &s_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i(13)%i
     &array0, Agrif_tabvars_i(2)%iarray0)

      end


#include "Sub_Loop_Agrif_update_np1.h"
      subroutine ExchangeParentValuesTracers()      


      use Agrif_Util
#include "Param_BeforeCall_ExchangeParentValuesTracers.h"
      

        call Sub_Loop_ExchangeParentValuesTracers( Agrif_tabvars_i(14)%i
     &array0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i(13)%iarray0, A
     &grif_tabvars_i(2)%iarray0, Agrif_tabvars_i(155)%iarray0, Agrif_tab
     &vars(148)%array5)

      end


#include "Sub_Loop_ExchangeParentValuesTracers.h"

      subroutine Agrif_update_uv_np1
      

      use Agrif_Util
#include "Param_BeforeCall_Agrif_update_uv_np1.h"
      

        call Sub_Loop_Agrif_update_uv_np1( Agrif_tabvars_i(196)%iarray0,
     & Agrif_tabvars_i(197)%iarray0, Agrif_tabvars_i(231)%iarray0, Agrif
     &_tabvars_i(8)%iarray0, Agrif_tabvars_i(7)%iarray0, Agrif_tabvars_i
     &(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i(13)%iarr
     &ay0, Agrif_tabvars_i(2)%iarray0)

      end


#include "Sub_Loop_Agrif_update_uv_np1.h"
      Subroutine UpdateTranp1pre(tabres,i1,i2,j1,j2,k1,k2,l1,l2,before)      


      use Agrif_Util
#include "Param_BeforeCall_UpdateTranp1pre.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      integer(4) :: k1
      integer(4) :: k2
      integer(4) :: l1
      integer(4) :: l2
      real, dimension(i1:i2,j1:j2,k1:k2,l1:l2) :: tabres
      logical :: before
      

        call Sub_Loop_UpdateTranp1pre(tabres,i1,i2,j1,j2,k1,k2,l1,l2,bef
     &ore, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agri
     &f_tabvars_i(13)%iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars
     &_l(23)%larray3, Agrif_tabvars(81)%array2, Agrif_tabvars_i(154)%iar
     &ray0, Agrif_tabvars(148)%array5, Agrif_tabvars_i(8)%iarray0, Agrif
     &_tabvars_i(7)%iarray0)

      end


#include "Sub_Loop_UpdateTranp1pre.h"
      Subroutine Updateunp1pre(tabres,i1,i2,j1,j2,k1,k2,before,nb,ndir)      


      use Agrif_Util
#include "Param_BeforeCall_Updateunp1pre.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      integer(4) :: k1
      integer(4) :: k2
      integer(4) :: nb
      integer(4) :: ndir
      real, dimension(i1:i2,j1:j2,k1:k2) :: tabres
      logical :: before
      

        call Sub_Loop_Updateunp1pre(tabres,i1,i2,j1,j2,k1,k2,before,nb,n
     &dir, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agri
     &f_tabvars_i(13)%iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars
     &_l(23)%larray3, Agrif_tabvars(47)%array3, Agrif_tabvars(79)%array2
     &, Agrif_tabvars(145)%array3, Agrif_tabvars_i(8)%iarray0, Agrif_tab
     &vars_i(7)%iarray0)

      end


#include "Sub_Loop_Updateunp1pre.h"
      Subroutine Updatevnp1pre(tabres,i1,i2,j1,j2,k1,k2,before,nb,ndir)      


      use Agrif_Util
#include "Param_BeforeCall_Updatevnp1pre.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      integer(4) :: k1
      integer(4) :: k2
      integer(4) :: nb
      integer(4) :: ndir
      real, dimension(i1:i2,j1:j2,k1:k2) :: tabres
      logical :: before
      

        call Sub_Loop_Updatevnp1pre(tabres,i1,i2,j1,j2,k1,k2,before,nb,n
     &dir, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agri
     &f_tabvars_i(13)%iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars
     &_l(23)%larray3, Agrif_tabvars(46)%array3, Agrif_tabvars(78)%array2
     &, Agrif_tabvars(144)%array3, Agrif_tabvars_i(8)%iarray0, Agrif_tab
     &vars_i(7)%iarray0)

      end


#include "Sub_Loop_Updatevnp1pre.h"
      Subroutine UpdateTranp1(tabres,i1,i2,j1,j2,k1,k2,l1,l2,before)      


      use Agrif_Util
#include "Param_BeforeCall_UpdateTranp1.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      integer(4) :: k1
      integer(4) :: k2
      integer(4) :: l1
      integer(4) :: l2
      real, dimension(i1:i2,j1:j2,k1:k2,l1:l2) :: tabres
      logical :: before
      

        call Sub_Loop_UpdateTranp1(tabres,i1,i2,j1,j2,k1,k2,l1,l2,before
     &, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_t
     &abvars_i(13)%iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars(81
     &)%array2, Agrif_tabvars_i(155)%iarray0, Agrif_tabvars(148)%array5)

      end


#include "Sub_Loop_UpdateTranp1.h"
      Subroutine Updatemyfx(tabres,i1,i2,j1,j2,k1,k2,l1,l2,before,
     &   nb,ndir)      


      use Agrif_Util
#include "Param_BeforeCall_Updatemyfx.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      integer(4) :: k1
      integer(4) :: k2
      integer(4) :: l1
      integer(4) :: l2
      real, dimension(i1:i2,j1:j2,k1:k2,l1:l2) :: tabres
      logical :: before
      integer(4) :: nb
      integer(4) :: ndir
      

        call Sub_Loop_Updatemyfx(tabres,i1,i2,j1,j2,k1,k2,l1,l2,before,n
     &b,ndir, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, A
     &grif_tabvars_i(13)%iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabv
     &ars(143)%array3, Agrif_tabvars(103)%array2, Agrif_tabvars(104)%arr
     &ay2, Agrif_tabvars_i(155)%iarray0, Agrif_tabvars(148)%array5, Agri
     &f_tabvars(57)%array4, Agrif_tabvars_i(8)%iarray0, Agrif_tabvars_i(
     &7)%iarray0)

      end


#include "Sub_Loop_Updatemyfx.h"
      Subroutine Updatemyfy(tabres,i1,i2,j1,j2,k1,k2,l1,l2,before,
     &                      nb,ndir)      


      use Agrif_Util
#include "Param_BeforeCall_Updatemyfy.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      integer(4) :: k1
      integer(4) :: k2
      integer(4) :: l1
      integer(4) :: l2
      real, dimension(i1:i2,j1:j2,k1:k2,l1:l2) :: tabres
      logical :: before
      integer(4) :: nb
      integer(4) :: ndir
      

        call Sub_Loop_Updatemyfy(tabres,i1,i2,j1,j2,k1,k2,l1,l2,before,n
     &b,ndir, Agrif_tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, A
     &grif_tabvars_i(13)%iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabv
     &ars(143)%array3, Agrif_tabvars(103)%array2, Agrif_tabvars(104)%arr
     &ay2, Agrif_tabvars_i(155)%iarray0, Agrif_tabvars(148)%array5, Agri
     &f_tabvars(56)%array4, Agrif_tabvars_i(8)%iarray0, Agrif_tabvars_i(
     &7)%iarray0)

      end


#include "Sub_Loop_Updatemyfy.h"
      Subroutine Updateunp1(tabres,i1,i2,j1,j2,k1,k2,before)      


      use Agrif_Util
#include "Param_BeforeCall_Updateunp1.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      integer(4) :: k1
      integer(4) :: k2
      real, dimension(i1:i2,j1:j2,k1:k2) :: tabres
      logical :: before
      

        call Sub_Loop_Updateunp1(tabres,i1,i2,j1,j2,k1,k2,before, Agrif_
     &tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i
     &(13)%iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars(79)%array2
     &, Agrif_tabvars_i(155)%iarray0, Agrif_tabvars(150)%array4)

      end


#include "Sub_Loop_Updateunp1.h"
      Subroutine Updatevnp1(tabres,i1,i2,j1,j2,k1,k2,before)      


      use Agrif_Util
#include "Param_BeforeCall_Updatevnp1.h"
      integer(4) :: i1
      integer(4) :: i2
      integer(4) :: j1
      integer(4) :: j2
      integer(4) :: k1
      integer(4) :: k2
      real, dimension(i1:i2,j1:j2,k1:k2) :: tabres
      logical :: before
      

        call Sub_Loop_Updatevnp1(tabres,i1,i2,j1,j2,k1,k2,before, Agrif_
     &tabvars_i(14)%iarray0, Agrif_tabvars_i(4)%iarray0, Agrif_tabvars_i
     &(13)%iarray0, Agrif_tabvars_i(2)%iarray0, Agrif_tabvars(78)%array2
     &, Agrif_tabvars_i(155)%iarray0, Agrif_tabvars(149)%array4)

      end


#include "Sub_Loop_Updatevnp1.h"
